{ 2 Geraden sind in Parameterdarstellung gegeben. Die zweite Gerade formt
  man in Normalvektorform um.  (1)   P = O1 + t1*U1
                               (2)   P = O2 + t2*U2  -->  (P-O2)*N2 = 0
  Zuvor muessen die Richtungsvektoren U1 und U2 normiert werden !!!!
  Wir setzen die erste Gleichung in die zweite Gleichung ein.:
  (O1 + t1*U1 - O2)*N2 = 0
  Wir bilden die Vektordifferenz von (O1 - O2) und nennen sie DV.:
  (DV + t1*U1)*N2 = 0
  Wir multiplizieren aus:
  DV*N2 + t1*(U1*N2) = 0
  Wir bilden jetzt die zwei skalaren Produkte DV*N2 und U1*N2 und nennen
  DV*N2 Num fuer numerator(= Zaehler) und U1*N2 Den fuer denominator(=Nenner)
  Num + t1*Den = 0
  Wenn U1*N2 Null ist, sind die Richtungsvektoren kollinear, das heisst die
  Geraden sind parallel oder identisch. Die Orientierung kann aber immer noch
  verschieden sein.
  Nur wenn U1*N2 ungleich Null ist, dann berechnen wir den Parameter t1:
  t1 = -Num/Den
  Diesen Parameter setzen wir in die erste Geradengleichung ein, und er-
  halten so den zugehoerigen Punkt S. Damit ist das Problem geloest. Wir
  berechnen aber noch den Parameterwert t2 der zweiten Geraden. Dazu bilden
  wir die Vektordifferenz S - O2 und nennen sie V. Dieser Vektor V hat jetzt
  die gleiche Richtung wie der Richtungsvektor U2. Wenn ich jetzt das Skalar
  produkt von V und U2 bilde, erhalte ich den Parameter t2. Deswegen, weil U2
  ja ein Einheitsvektor ist und daher die Laenge 1 hat. Damit ist naemlich
  t2 genau der Faktor mit dem ich den Betrag von U2 multiplizieren muss,
  um den Betrag von V zu erhalten.                                          }

{$N+}
PROGRAM Schnitt;                      (* Schnitt zweier Geraden 2.2.1997 *)
USES CRT,UNIGRA12;

CONST
Eps = 1.0E-4;

TYPE
Line2D = RECORD                                                     
             O: Pt2D;
             U: Vt2D;
           END;

VAR
Line1,Line2 : Line2D;                     (* 2 Linien                     *)
t1,t2       : EXTENDED;                   (* Parameter der beiden Geraden *)
S           : Pt2D;                       (* Schnittpunkt                 *)
geschnitten : BOOLEAN;                    (* Wenn Schnittpunkt, dann TRUE *)

{ ------------------------- Unterprogramme ------------------------------ }
Procedure Ausgangszustand_definieren;
   BEGIN
   Plotter_einschalten;
   Graphik_einschalten('');
   Weltgrenzen_festlegen(einh);  
   Viewport_festlegen;
   GeraetefensterPlotter_festlegen;
   Parameter2D;
   Portrait  := FALSE;                   (* Querformat Bild liegend        *)
   Plast.X := WI2D[1].X;                 (* letzter Punkt initialisieren   *)
   Plast.Y := WI2D[1].Y;
   Viewport_zeichnen; 
   Koordinatenachsen_zeichnen;
   Gitter(0.3,2.0,10.0);  (* Strich,              klE,             grE     *)
                        (* grosse Strichlaenge,kleine Einheit, grosse Einh *)
  END;

Procedure Beschriftung(S:Pt2D;Line1,Line2: Line2D);
  VAR
  XUntergr,XObergr,YUntergr,YObergr,einhS,SXS,SYS: STRING[Bz1];
  Line1OXS,Line1OYS,Line1UXS,Line1UYS            : STRING[Bz1];
  Line2OXS,Line2OYS,Line2UXS,Line2UYS            : STRING[Bz1];
  Ttemp1,Ttemp2: STRING[Bz2];
  T: Ttyp;

  BEGIN
  STR(WI2D[1].X:5:1,XUntergr); STR(WI2D[1].Y:5:1,YUntergr);
  STR(WI2D[2].X:5:1,XObergr);  STR(WI2D[2].Y:5:1,YObergr);
  STR(einh:5:3,einhS);
  STR(S.X:5:2,SXS);   STR(S.Y:5:2,SYS);
  STR(Line1.O.X:5:2,Line1OXS);  STR(Line1.O.Y:5:2,Line1OYS);
  STR(Line1.U.X:5:2,Line1UXS);  STR(Line1.U.Y:5:2,Line1UYS);
  STR(Line2.O.X:5:2,Line2OXS);  STR(Line2.O.Y:5:2,Line2OYS);
  STR(Line2.U.X:5:2,Line2UXS);  STR(Line2.U.Y:5:2,Line2UYS);

(* ----------------------------- TEXTE --------------------------------- *)
  T[1] := 'Schnitt zweier Geraden:';
  Ttemp1 := 'Gerade1; Punkt('+Line1OXS+'/'+Line1OYS+')';
  Ttemp2 := ' Richtungsvektor('+Line1UXS+'/'+Line1UYS+')';
  T[2] := Ttemp1 + Ttemp2;
  Ttemp1 := 'Gerade2: Punkt('+Line2OXS+'/'+Line2OYS+')';
  Ttemp2 := ' Richtungsvektor('+Line2UXS+'/'+Line2UYS+')';
  T[3] := Ttemp1 + Ttemp2;
        Ttemp1 := 'Weltgrenzen: X von '+XUntergr+' bis '+XObergr;
        Ttemp2 := '   Y von '+YUntergr+' bis '+YObergr;
  T[4] := Ttemp1 + Ttemp2;
  T[5] := '1 Einheit entspricht '+einhS+'  cm';
  IF geschnitten THEN T[6] := 'Schnittpunkt: ('+SXS+'/'+SYS+')'
                 ELSE T[6] := 'kein Schnittpunkt: Richtungsvektor kollinear';
  Text_ausgeben(T,6);                                 (* 2 Texte ausgeben *)
  END;

PROCEDURE LengthVt2D(V: Vt2D; VAR L: EXTENDED);
BEGIN
  L := SQRT(SQR(V.X)+SQR(V.Y)+Eps);
END;

PROCEDURE ScaleVt2D(V: Vt2D; LG: EXTENDED; VAR ScalV: Vt2D);
VAR L: EXTENDED;
BEGIN
  ScalV:=V;
  LengthVt2D(V, L);
  IF NOT Null(L,Eps) THEN BEGIN
    ScalV.X:=V.X/L*LG;
    ScalV.Y:=V.Y/L*LG;
  END;
END;

PROCEDURE DifferenceVt2D(V1,V2: Vt2D; VAR DV: Vt2D);
BEGIN
  DV.X:=V1.X-V2.X;
  DV.Y:=V1.Y-V2.Y;
END;

PROCEDURE LinearCombinationVt2D(S1,S2: EXTENDED; V1,V2: Vt2D; VAR LC: Vt2D);
BEGIN
  LC.X:=S1*V1.X+S2*V2.X;
  LC.Y:=S1*V1.Y+S2*V2.Y;
END;

PROCEDURE ScalarProductVt2D(V1,V2: Vt2D; VAR SP: EXTENDED);
BEGIN
  SP:=V1.X*V2.X+V1.Y*V2.Y;
END;

PROCEDURE TToLine2D(Ln2D: Line2D; T: EXTENDED; VAR P: Pt2D);
BEGIN
  LinearCombinationVt2D(1,T,Ln2D.O,Ln2D.U, P);
END;

PROCEDURE IntersectionLines2D(Line1,Line2: Line2D; VAR Intsec: BOOLEAN;
                              VAR T1,T2: EXTENDED; VAR S: Pt2D);
VAR Num,Den: EXTENDED;
    N2,DV: Vt2D;
    V: Vt2D;
BEGIN
  Intsec := FALSE;
  N2.X := Line2.U.Y; N2.Y := -Line2.U.X;
  DifferenceVt2D(Line1.O, Line2.O, DV);
  ScalarProductVt2D(DV,N2, Num);
  ScalarProductVt2D(Line1.U,N2, Den);
  IF NOT Null(Den,Eps) THEN BEGIN
    T1 := -Num/Den;
    TToLine2D(Line1,T1, S);
    DifferenceVt2D(S,Line2.O, V);       (* nicht mehr notwendig, nur mehr *)
    ScalarProductVt2D(V,Line2.U, T2);   (* zur Berechnung von t2          *)
    Intsec := TRUE;
  END;
END;

PROCEDURE Eingabe;                (* Gerade geg: durch Punkt und Richtung *)
  BEGIN
  Line1.O.X :=  -5.00;   Line1.O.Y :=  -2.80;           (* fester Punkt   *)
  Line1.U.X :=   0.00;   Line1.U.Y :=   0.01;           (* Richtunsvektor *)
  Line2.O.X :=   6.18;   Line2.O.Y :=   8.81;           (* fester Punkt   *)
  Line2.U.X :=   9.01;   Line2.U.Y :=  -1.01;           (* Richtunsvektor *)

  ScaleVt2D(Line1.U,1.0,Line1.U);   (* Richtungsvektor als Einheitsvektor *)
  ScaleVt2D(Line2.U,1.0,Line2.U);   (* normieren                          *)
  END;


PROCEDURE Zeichnen;
  VAR
  P1,P2: Pt2D;
  BEGIN
  TToLine2D(Line1,-200,P1);  TToLine2D(Line1,200,P2);
  DrawLine2D(P1,P2,2);
  TToLine2D(Line2,-200,P1);  TToLine2D(Line2,200,P2);
  DrawLine2D(P1,P2,3);
  END;

{ -------------------------- main program -------------------------------- }
BEGIN
 Schnittstelle_waehlen(1);                 (* 2 bedeutet auf Datei plotten *)
  Plot := FALSE;                           (* 1 ist parallele Schnittst    *)
  einh := 0.5;   (* 1 Einheit auf der X-Achse und Y-Achse entspricht .. cm *)
  WI2D[1].X := -20.0;  WI2D[1].Y := -20.0;     (* linker unterer Punkt     *)
                                               (* des Weltfensters         *)
  Ausgangszustand_definieren;                 (* Graphikgrundeinstellung   *)
  Eingabe;
  IntersectionLines2D(Line1,Line2,geschnitten,t1,t2,S);
  Zeichnen;
  Beschriftung(S,Line1,Line2); 
  WClosegraph;
END.